import { Node, SourceFileNode, ContractNode, ParameterNode, VariableDefinitionNode, FunctionDefinitionNode, AssignNode, IdentifierNode, BranchNode, CastNode, FunctionCallNode, UnaryOpNode, BinaryOpNode, BoolLiteralNode, IntLiteralNode, HexLiteralNode, StringLiteralNode, BlockNode, TimeOpNode, ArrayNode, TupleIndexOpNode, RequireNode, InstantiationNode, TupleAssignmentNode, NullaryOpNode } from './AST.js';
import AstVisitor from './AstVisitor.js';
export default class AstTraversal extends AstVisitor<Node> {
    visitSourceFile(node: SourceFileNode): Node;
    visitContract(node: ContractNode): Node;
    visitFunctionDefinition(node: FunctionDefinitionNode): Node;
    visitParameter(node: ParameterNode): Node;
    visitVariableDefinition(node: VariableDefinitionNode): Node;
    visitTupleAssignment(node: TupleAssignmentNode): Node;
    visitAssign(node: AssignNode): Node;
    visitTimeOp(node: TimeOpNode): Node;
    visitRequire(node: RequireNode): Node;
    visitBranch(node: BranchNode): Node;
    visitBlock(node: BlockNode): Node;
    visitCast(node: CastNode): Node;
    visitFunctionCall(node: FunctionCallNode): Node;
    visitInstantiation(node: InstantiationNode): Node;
    visitTupleIndexOp(node: TupleIndexOpNode): Node;
    visitBinaryOp(node: BinaryOpNode): Node;
    visitUnaryOp(node: UnaryOpNode): Node;
    visitNullaryOp(node: NullaryOpNode): Node;
    visitArray(node: ArrayNode): Node;
    visitIdentifier(node: IdentifierNode): Node;
    visitBoolLiteral(node: BoolLiteralNode): Node;
    visitIntLiteral(node: IntLiteralNode): Node;
    visitStringLiteral(node: StringLiteralNode): Node;
    visitHexLiteral(node: HexLiteralNode): Node;
}
