import { ANTLRErrorListener, RecognitionException, Recognizer } from 'antlr4ts';
/**
 * ANTLR Error Listener that immediately throws on error. This is used so that
 * ANTLR doesn't attempt any error recovery during lexing/parsing and fails early.
 */
export default class ThrowingErrorListener implements ANTLRErrorListener<any> {
    static readonly INSTANCE: ThrowingErrorListener;
    syntaxError<T>(recognizer: Recognizer<T, any>, offendingSymbol: T, line: number, charPositionInLine: number, message: string, e?: RecognitionException): void;
}
