import { Node, ContractNode, ParameterNode, VariableDefinitionNode, FunctionDefinitionNode, AssignNode, IdentifierNode, BranchNode, CastNode, FunctionCallNode, UnaryOpNode, BinaryOpNode, BoolLiteralNode, IntLiteralNode, HexLiteralNode, StringLiteralNode, BlockNode, TimeOpNode, ArrayNode, TupleIndexOpNode, RequireNode, InstantiationNode, TupleAssignmentNode, NullaryOpNode } from '../ast/AST.js';
import AstTraversal from '../ast/AstTraversal.js';
export default class OutputSourceCodeTraversal extends AstTraversal {
    private indentationLevel;
    output: string;
    private addOutput;
    private getIndentation;
    private indent;
    private unindent;
    private outputSymbolTable;
    visitContract(node: ContractNode): Node;
    visitFunctionDefinition(node: FunctionDefinitionNode): Node;
    visitCommaList(list: Node[]): Node[];
    visitParameter(node: ParameterNode): Node;
    visitVariableDefinition(node: VariableDefinitionNode): Node;
    visitTupleAssignment(node: TupleAssignmentNode): Node;
    visitAssign(node: AssignNode): Node;
    visitTimeOp(node: TimeOpNode): Node;
    visitRequire(node: RequireNode): Node;
    visitBranch(node: BranchNode): Node;
    visitBlock(node: BlockNode): Node;
    visitCast(node: CastNode): Node;
    visitFunctionCall(node: FunctionCallNode): Node;
    visitInstantiation(node: InstantiationNode): Node;
    visitTupleIndexOp(node: TupleIndexOpNode): Node;
    visitBinaryOp(node: BinaryOpNode): Node;
    visitUnaryOp(node: UnaryOpNode): Node;
    visitNullaryOp(node: NullaryOpNode): Node;
    visitArray(node: ArrayNode): Node;
    visitIdentifier(node: IdentifierNode): Node;
    visitBoolLiteral(node: BoolLiteralNode): Node;
    visitIntLiteral(node: IntLiteralNode): Node;
    visitStringLiteral(node: StringLiteralNode): Node;
    visitHexLiteral(node: HexLiteralNode): Node;
}
